/*
	upgrade DD_Statuses - add a TreatAsCompleted field
*/
ALTER TABLE DD_Statuses ADD TreatAsCompleted BIT NULL
GO

/*
	upgrade TT_Statuses - add a TreatAsCompleted field
*/
ALTER TABLE TT_Statuses ADD TreatAsCompleted BIT NULL	
GO

UPDATE TT_Statuses SET TreatAsCompleted = 0
GO

-- Update treatAsCompleted field for statuses
DECLARE curstatus CURSOR FOR
	SELECT StatusID FROM TT_Statuses

DECLARE @statusid int

OPEN curstatus
FETCH NEXT FROM curstatus INTO @statusid

WHILE(@@FETCH_STATUS = 0)
BEGIN
	
	UPDATE TT_Statuses SET TreatAsCompleted = 1 WHERE StatusID = @statusid AND Number = 2 AND StatusType='Project'
	UPDATE TT_Statuses SET TreatAsCompleted = 1 WHERE StatusID = @statusid AND Number = 4 AND StatusType='Task'
	UPDATE TT_Statuses SET TreatAsCompleted = 1 WHERE StatusID = @statusid AND Number = 4 AND StatusType='Request'
	UPDATE TT_Statuses SET TreatAsCompleted = 1 WHERE StatusID = @statusid AND Number = 5 AND StatusType='Bug'
	UPDATE TT_Statuses SET TreatAsCompleted = 1 WHERE StatusID = @statusid AND Number = 5 AND StatusType='Request'
	UPDATE TT_Statuses SET TreatAsCompleted = 1 WHERE StatusID = @statusid AND Number = 6 AND StatusType='Bug'
	UPDATE TT_Statuses SET TreatAsCompleted = 1 WHERE StatusID = @statusid AND Number = 7 AND StatusType='Bug'
	
	
	FETCH NEXT FROM curstatus INTO @statusid
END


CLOSE curstatus
DEALLOCATE curstatus

GO

UPDATE DD_Statuses SET TreatAsCompleted = 0
UPDATE DD_Statuses SET TreatAsCompleted = 1 WHERE Number = 2 AND StatusType='Project'
UPDATE DD_Statuses SET TreatAsCompleted = 1 WHERE Number = 4 AND StatusType='Task'
UPDATE DD_Statuses SET TreatAsCompleted = 1 WHERE Number = 4 AND StatusType='Request'
UPDATE DD_Statuses SET TreatAsCompleted = 1 WHERE Number = 5 AND StatusType='Bug'
UPDATE DD_Statuses SET TreatAsCompleted = 1 WHERE Number = 5 AND StatusType='Request'
UPDATE DD_Statuses SET TreatAsCompleted = 1 WHERE Number = 6 AND StatusType='Bug'
UPDATE DD_Statuses SET TreatAsCompleted = 1 WHERE Number = 7 AND StatusType='Bug'

GO

UPDATE DD_Statuses SET TreatAsCompleted = 0
UPDATE DD_Statuses SET TreatAsCompleted = 1 WHERE Number = 2 AND StatusType='Project'
UPDATE DD_Statuses SET TreatAsCompleted = 1 WHERE Number = 4 AND StatusType='Task'
UPDATE DD_Statuses SET TreatAsCompleted = 1 WHERE Number = 4 AND StatusType='Request'
UPDATE DD_Statuses SET TreatAsCompleted = 1 WHERE Number = 5 AND StatusType='Bug'
UPDATE DD_Statuses SET TreatAsCompleted = 1 WHERE Number = 5 AND StatusType='Request'
UPDATE DD_Statuses SET TreatAsCompleted = 1 WHERE Number = 6 AND StatusType='Bug'
UPDATE DD_Statuses SET TreatAsCompleted = 1 WHERE Number = 7 AND StatusType='Bug'

UPDATE TT_Statuses SET TreatAsCompleted = 1 WHERE Number = 2 AND StatusType='Project'
UPDATE TT_Statuses SET TreatAsCompleted = 1 WHERE Number = 4 AND StatusType='Task'
UPDATE TT_Statuses SET TreatAsCompleted = 1 WHERE Number = 4 AND StatusType='Request'
UPDATE TT_Statuses SET TreatAsCompleted = 1 WHERE Number = 5 AND StatusType='Bug'
UPDATE TT_Statuses SET TreatAsCompleted = 1 WHERE Number = 5 AND StatusType='Request'
UPDATE TT_Statuses SET TreatAsCompleted = 1 WHERE Number = 6 AND StatusType='Bug'
UPDATE TT_Statuses SET TreatAsCompleted = 1 WHERE Number = 7 AND StatusType='Bug'
GO

DECLARE projcur CURSOR FOR
	SELECT ProjectID FROM TT_Projects

DECLARE @projid int
DECLARE @priorityCount int

OPEN projcur
FETCH NEXT FROM projcur INTO @projid

WHILE @@FETCH_STATUS = 0
BEGIN
	SET @priorityCount = (SELECT COUNT(BugPriorityID) FROM TT_Priorities WHERE ProjectID=@projid)
	
	IF @priorityCount = 0
	BEGIN
		PRINT 'Fixing priorities for project ID ' + CAST(@projid AS nvarchar)
		
		-- priorities
		INSERT INTO TT_Priorities (Number, Name, ProjectID)
		VALUES (1,'Urgent', @projid)

		INSERT INTO TT_Priorities (Number, Name, ProjectID)
		VALUES (2,'High', @projid)
		
		INSERT INTO TT_Priorities (Number, Name, ProjectID)
		VALUES (3,'Medium', @projid)
		
		INSERT INTO TT_Priorities (Number, Name, ProjectID)
		VALUES (4,'Low', @projid)
	END

	FETCH NEXT FROM projcur INTO @projid
END

CLOSE projcur
DEALLOCATE projcur
GO

-- Check if Verified & Closed status is present in TT_Statuses
-- and add it if necessary
-- ***************************************
DECLARE statcur CURSOR FOR
	SELECT ProjectID FROM TT_Statuses

DECLARE @projid int
DECLARE @statcount int
DECLARE @freenumber int
DECLARE @statname nvarchar

PRINT 'Adding new status: verified and closed'

OPEN statcur 
FETCH NEXT FROM statcur INTO @projid

WHILE(@@FETCH_STATUS = 0)
BEGIN
	SET @statcount = (SELECT COUNT(StatusID) 
			FROM TT_Statuses 
			WHERE ProjectID = @projid	AND StatusType='Bug' AND Number = 7)
	
	if @statcount = 0
	BEGIN
		PRINT 'Adding new status'
		INSERT INTO TT_Statuses(ProjectID, StatusName, Number, StatusType, TreatAsCompleted)
			VALUES (@projid, 'Verified & Closed', 7, 'Bug', 1)
	END
	ELSE BEGIN
		SET @statcount = (SELECT COUNT(StatusID)
			FROM TT_Statuses 
			WHERE ProjectID = @projid	AND StatusType='Bug' AND StatusName = 'Verified & Closed')

		IF @statcount = 0
		BEGIN
		PRINT 'Number 7 already exists and is not verified and closed. Adding another'

			SET @freenumber = (SELECT MAX(Number) FROM TT_Statuses 
				WHERE ProjectID = @projid AND StatusType='Bug') + 1
				
			INSERT INTO TT_Statuses(ProjectID, StatusName, Number, StatusType, TreatAsCompleted)
				VALUES (@projid, 'Verified & Closed', @freenumber, 'Bug', 1)
		END
	END

	FETCH NEXT FROM statcur INTO @projid			
END

CLOSE statcur
DEALLOCATE statcur
-- ***************************************


UPDATE TT_Version SET Major=3, Minor=2, Build=2
