if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[vwTaskAssignee]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view [dbo].[vwTaskAssignee]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[vwTaskAssignee_Lite]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view [dbo].[vwTaskAssignee_Lite]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[vwTasks]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view [dbo].[vwTasks]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[vwTasks_Lite]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view [dbo].[vwTasks_Lite]
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

CREATE VIEW dbo.vwTasks_Lite
AS
SELECT     ts.TaskID, ts.Description, ts.ParentID, ts.ProjectID, ts.Status, ts.EstCompletionDate, ts.EstDuration, ts.CategoryID, ts.Title, ts.Billable, ts.BillType, 
                      ts.Amount, ts.StartDate, ts.PercentCompleted, ts.Priority, ts.TaskType, ts.BugType, ts.CustomData, pj.Name AS ProjectTitle, 
                      st.StatusName AS StatusName, bgt.Name AS BugTypeString, pri.Name AS PriorityName, csd.CustomerID AS CustomerID, csd.CompanyName, 
                      st.TreatAsCompleted, cat.Name AS CategoryName, ddt.TypeName AS TaskTypeName
FROM         dbo.TT_Tasks ts INNER JOIN
                      dbo.TT_Projects pj ON pj.ProjectID = ts.ProjectID LEFT OUTER JOIN
                      dbo.DD_BugTypes bgt ON bgt.Number = ts.BugType INNER JOIN
                      dbo.DD_Priorities pri ON pri.Number = ts.Priority LEFT OUTER JOIN
                      dbo.TT_CustomerDetails csd ON csd.CustomerID = pj.CustomerID INNER JOIN
                      dbo.TT_Categories cat ON cat.CategoryID = ts.CategoryID INNER JOIN
                      dbo.DD_TaskTypes ddt ON ddt.ID = ts.TaskType INNER JOIN
                      dbo.DD_Statuses st ON st.StatusType = ddt.TypeName AND st.Number = ts.Status

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

CREATE VIEW dbo.vwTasks
AS 
SELECT     ts.*, wfl1.DisplayName AS CreatedByName, wfl1.UserID AS CreatedBy, 
                      wfl2.DisplayName AS CompletedByName, wfl2.UserID AS CompletedBy, dbo.ep_getTaskAttachCount(ts.TaskID) AS AttachCount, 
                      dbo.ep_getTaskMessageCount(ts.TaskID) AS MessageCount, wfl1.EntryDate AS CreationDate, 
                      dbo.ep_wflGetLastRecordedDateForTask(ts.TaskID) AS LastStatusChangeDate
FROM         dbo.vwTasks_Lite  ts
 LEFT OUTER JOIN
                      dbo.vwTaskWorkflow wfl1 ON wfl1.TaskID = ts.TaskID AND wfl1.Action = 1 LEFT OUTER JOIN
                      dbo.vwTaskWorkflow wfl2 ON wfl2.TaskID = ts.TaskID AND wfl2.Action = 2 AND wfl2.CustomAction = 4 
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

CREATE VIEW dbo.vwTaskAssignee
AS 
SELECT     ts.TaskID, ts.Description, ts.ParentID, ts.ProjectID, ts.Status, ts.EstCompletionDate, ts.EstDuration, ts.CategoryID, ts.Title, ts.Billable, 
	     ts.BillType, ts.Amount, ts.StartDate, ts.PercentCompleted, ts.Priority, ts.TaskType, ts.BugType, ts.CustomData,
	     ts.ProjectTitle, ts.StatusName, ts.CreatedByName, ts.CreatedBy, 
                  ts.CompletedByName, ts.CompletedBy, ts.AttachCount, 
                  ts.MessageCount, ts.CreationDate, ts.BugTypeString, ts.PriorityName, 
                  ts.LastStatusChangeDate, ts.CustomerID, ts.CompanyName, 
                  ts.TreatAsCompleted, ts.CategoryName, ts.TaskTypeName,
	     tsa.UserID AS AssignedToId, us.DisplayName AS AssignedToName
FROM         dbo.vwTasks ts LEFT OUTER JOIN
                      dbo.TT_TaskAssignee tsa ON tsa.TaskID = ts.TaskID LEFT OUTER JOIN
                      dbo.TT_Users us ON us.UserID = tsa.UserID
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

CREATE VIEW dbo.vwTaskAssignee_Lite
AS
SELECT     ts.*, tsa.UserID AS AssignedToId, us.DisplayName AS AssignedToName
FROM         dbo.vwTasks_Lite ts LEFT OUTER JOIN
                      dbo.TT_TaskAssignee tsa ON tsa.TaskID = ts.TaskID LEFT OUTER JOIN
                      dbo.TT_Users us ON us.UserID = tsa.UserID

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[ep_requestAssignedTasks]') and xtype in (N'FN', N'IF', N'TF'))
drop function [dbo].[ep_requestAssignedTasks]
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

CREATE FUNCTION dbo.ep_requestAssignedTasks
	(
		@assignedToId int,
		@taskType int
	)
RETURNS TABLE
AS
	RETURN 
	SELECT * FROM vwTaskAssignee_Lite WHERE AssignedToId = @assignedToId AND TaskType=@taskType

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

UPDATE TT_Version SET Major=4, Minor=0, Build=2, MinorBuild=1
