-- fix bug when tasks created by user do not treated as own
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[ep_requestAssignedTasks]') )
DROP FUNCTION [dbo].[ep_requestAssignedTasks]
GO

CREATE FUNCTION [dbo].[ep_requestOwnTasks]
	(
		@userId int,
		@taskType int
	)
RETURNS TABLE
AS
	RETURN 
	SELECT * FROM vwTaskAssignee WHERE ((AssignedToId = @userId) or (CreatedBy = @userId)) AND TaskType=@taskType
GO

-- fix bug when customer is deleted but its project reference does not
UPDATE TT_Projects 
SET TT_Projects.CustomerID = NULL
WHERE TT_Projects.CustomerID NOT IN (SELECT cd.CustomerID FROM TT_CustomerDetails AS cd)
GO

CREATE TRIGGER [OnDeleteCustomer] ON [dbo].[TT_CustomerDetails] 
FOR  DELETE 
AS
UPDATE TT_Projects
SET TT_Projects.CustomerID = NULL
WHERE TT_Projects.CustomerID in (select deleted.CustomerID from deleted)
GO

-- retry fixing Message object
UPDATE NF_Actions SET Target='Message' WHERE Target='MessageBoard'
GO

UPDATE TT_Version SET Major=4, Minor=0, Build=12, MinorBuild=1
GO